/*
 *  Phase.cpp
 *  emptyExample
 *
 *  Created by Andrew Wallace on 9/15/11.
 *  Copyright 2011 Cool Town Inc. All rights reserved.
 *
 */

#include "Phase.h"

//--------------------------------------------------------------
void Phase::setup(){
	for (int i=0; i<10; i++)
		waves[i].setup(0,3,700);
	
	startTime=ofGetElapsedTimeMillis();
	done=false;
				   
}

//--------------------------------------------------------------
void Phase::update(){
	int curTime=ofGetElapsedTimeMillis()-startTime;
	
	//timing
	int growTime= 4000;
	int spreadTime=growTime+4000;			//when to start spreaidng out
	int yShiftTime=spreadTime+7000;			//when to start moving them up
	int backDownTime=yShiftTime+40000;		//when to move them back together
	int sameFreqTime=backDownTime+50000;	//when to have them xeno back together
	int disappearTime=sameFreqTime+35000;	//when to have the line shift off screen
	
	//have the amplitude of the wave grow to 150
	if (curTime<growTime){
		float amp=ofMap(curTime, 0, growTime, 1, 150, true);
		for (int i=0; i<10; i++)
			waves[i].amp=amp;
	}
	
	//increase the frequencies incrimentaly once it has run for a little while
	if (curTime>spreadTime && curTime<sameFreqTime){
		for (int i=0; i<10; i++)
			waves[i].freq+=0.0001*i;
	}
	
	if (curTime>yShiftTime && curTime<backDownTime && waves[9].y>200 ){
		for (int i=0; i<10; i++)
			waves[i].y-=0.1*i;
	}
	
	if (curTime>backDownTime && curTime<sameFreqTime){
		//push them to the center
		float centerY=ofGetHeight()/2;
		for (int i=0; i<10; i++){
			if (waves[i].y>centerY)
				waves[i].y-=0.15;
			if (waves[i].y<centerY)
				waves[i].y+=0.15;
		}
	}
	
	if (curTime>sameFreqTime){
		//have all waves xeno their way to the frequency of the firts one
		for (int i=1; i<10; i++){
			//xeno to the point
			waves[i].freq=(1-0.005)*waves[i].freq + 0.005*waves[0].freq;
		}

	}
	
	if (curTime>disappearTime){
		for (int i=0; i<10; i++)
			waves[i].phase-=3;
		//are the waves offscreen
		if (waves[0].phase<=-ofGetWidth())	done=true;
	}
							
	
	
	cout<<curTime-sameFreqTime<<endl;
	
}

//--------------------------------------------------------------
void Phase::draw(){
	for (int i=0; i<10; i++)
		waves[i].draw();
}