/*
 *  circleTug.cpp
 *  emptyExample
 *
 *  Created by Andrew Wallace on 9/15/11.
 *  Copyright 2011 Cool Town Inc. All rights reserved.
 *
 */

#include "circleTug.h"

//--------------------------------------------------------------
void CircleTug::setup(){
	startX=0;					//x location of center point
	startY=0;					//y location of center point
	dist=100;					//radius
	expandDist=dist*1.5;
	
	//fill up the points with pints of a circle
	
		float incr= TWO_PI/CIRCLE_TUG_NUM;	//angle seperation of each point
	for (int i=0; i<CIRCLE_TUG_NUM; i++){
		pnts[i].x=startX+dist*cos(PI/2+incr*i);
		pnts[i].y=startY+dist*sin(PI/2+incr*i);
	}
	
	
	cycle=0;		//start with the first movement
	cycleMod=0;		
	repetitions=0;
	
	speed=2;
	
	done=false;
}

//--------------------------------------------------------------
void CircleTug::update(){
	//fuck with the speed
	speed=ofMap(sin(ofGetElapsedTimef()),-1,1,0.5,3);
	
	//pull at the points
	for (int i=0; i<CIRCLE_TUG_NUM; i++){
		//int distFromCenter= 
		//points furthest form the center get the most pull
		float pull=ofMap( i-CIRCLE_TUG_NUM/2, -CIRCLE_TUG_NUM/2, CIRCLE_TUG_NUM/2, speed, -speed);
		
		//manipulate them, based on cycle
		//pull bottom lines out
		if (cycle==0 || cycle==9)
			pnts[i].x+=pull;
		//push bottom lines in
		if (cycle==1 || cycle==8)
			pnts[i].x-=pull;		
		//pull top lines out
		if (cycle==2 || cycle==11)
			pnts[ (i+cycleMod)%CIRCLE_TUG_NUM ].x-=pull;
		if (cycle==3 || cycle==10)
			pnts[ (i+cycleMod)%CIRCLE_TUG_NUM ].x+=pull;
		//pull left lines out
		if (cycle==4)
			pnts[ (i+cycleMod)%CIRCLE_TUG_NUM ].y+=pull;
		if (cycle==5)
			pnts[ (i+cycleMod)%CIRCLE_TUG_NUM ].y-=pull;
		
		//pull right lines out
		if (cycle==6)
			pnts[ (i+cycleMod)%CIRCLE_TUG_NUM ].y-=pull;
		if (cycle==7)
			pnts[ (i+cycleMod)%CIRCLE_TUG_NUM ].y+=pull;
		
		
		// finish the animation have all points pull into a horizontal line 
		if (cycle==12){
			pnts[i].x+=pull;
			if (pnts[i].y<0)
				pnts[i].y+=1;
			else 
				pnts[i].y-=1;
		}
	}
	
	//Note : Expanding this twice leaves a pretty nice semi-circle
	
	//check if we're on to the next cycle
	//bottom
	if (cycle==0 && pnts[0].x>=startX+expandDist)
		cycle++;
	if (cycle==1 && pnts[0].x<=startX){
		cycle++;
		cycleMod=CIRCLE_TUG_NUM/2;	//start focussing on left wall
	}
	//bottom
	if (cycle==2 && pnts[cycleMod%CIRCLE_TUG_NUM].x<=startX-expandDist)
		cycle++;
	if (cycle==3 && pnts[cycleMod%CIRCLE_TUG_NUM].x>=startX){
		cycle++;
		cycleMod=CIRCLE_TUG_NUM/4;	//start focussing on left wall
	}
	//left
	if (cycle==4 && pnts[cycleMod%CIRCLE_TUG_NUM].y>=startY+expandDist)
		cycle++;
	if (cycle==5 && pnts[cycleMod%CIRCLE_TUG_NUM].y<=startY){
		cycle++;
		cycleMod=(CIRCLE_TUG_NUM/4)*3;	//start focussing on top wall
	}
	//right
	if (cycle==6 && pnts[cycleMod%CIRCLE_TUG_NUM].y<=startY-expandDist)
		cycle++;
	if (cycle==7 && pnts[cycleMod%CIRCLE_TUG_NUM].y>=startY){
		cycle++;
		cycleMod=0;					//return to the bottom
	}
	
	//pulling bottom to make semi-circle
	if (cycle==8 && pnts[0].x<=startX-dist*4.12)
		cycle++;
	if (cycle==9 && pnts[0].x>=startX){
		cycle++;
		cycleMod=CIRCLE_TUG_NUM/2;
	}
	//pulling top to make semi-circle
	if (cycle==10 && pnts[cycleMod%CIRCLE_TUG_NUM].x>=startX+dist*4.12)
		cycle++;
	if (cycle==11 && pnts[cycleMod%CIRCLE_TUG_NUM].x<=startX){
		cycle=0;		//reset it
		repetitions++;	//but mark that it has gone through a full cycle
		cycleMod=0;
	}
	
	//after enough repetitions, finish the animation
	if (repetitions==2){
		cycle=12;
		done=true;
	}
	

	
}

//--------------------------------------------------------------
void CircleTug::draw(){
	//draw a line connecting each point
	ofNoFill();
	ofBeginShape();
	for (int i=0; i<CIRCLE_TUG_NUM; i++)
		ofVertex(pnts[ (i+cycleMod) % CIRCLE_TUG_NUM].x,pnts[ (i+cycleMod) % CIRCLE_TUG_NUM ].y);
	ofEndShape(false);
	
	//Connect the shape if it is close
						

}